#import "BallView.h"

@implementation BallView

- (void)GLinit:sender
{
    Ball = 0;
    Zrot = 0.0, Zstep = 6.0;
    Xpos = 0.0, Ypos = 1.0;
    Xvel = 0.2, Yvel = 0.0;
    Xmin = -4.0, Xmax = 4.0;
    Ymin = -3.8, Ymax = 4.0;
    G = -0.1;

    Ball = [self makeBall];

    timer = [NSTimer scheduledTimerWithTimeInterval:(NSTimeInterval)0.05
	             target:self selector:@selector(display)
	             userInfo:nil repeats:YES];
    
    return;
}
	  

- (void)GLdraw:sender
{
    GLint i;
    static float vel0 = -100.0;
    
    glClear(GL_COLOR_BUFFER_BIT);
    
    glIndexi(CYAN);
    glBegin(GL_LINES);
    for (i = -5; i <= 5; i++) {
	glVertex2i(i, -5);
	glVertex2i(i, 5);
    }
    for (i = -5; i <= 5; i++) {
	glVertex2i(-5, i);
	glVertex2i(5, i);
    }
    for (i = -5; i <= 5; i++) {
	glVertex2i(i, -5);
	glVertex2f(i * 1.15, -5.9);
    }
    glVertex2f(-5.3, -5.35);
    glVertex2f(5.3, -5.35);
    glVertex2f(5.3, -5.35);
    glVertex2f(-5.75, -5.9);
    glVertex2f(5.75, -5.9);
    glEnd();
    
    glPushMatrix();
    glTranslatef(Xpos, Ypos, 0.0);
    glScalef(2.0, 2.0, 2.0);
    glRotatef(8.0, 0.0, 0.0, 1.0);
    glRotatef(90.0, 1.0, 0.0, 0.0);
    glRotatef(Zrot, 0.0, 0.0, 1.0);
    
    glCallList(Ball);
    
    glPopMatrix();
    
    glFlush();

    /* Prepare for next display cycle */
    
    Zrot += Zstep;
    
    Xpos += Xvel;
    if (Xpos >= Xmax) {
	Xpos = Xmax;
	Xvel = -Xvel;
	Zstep = -Zstep;
    }
    if (Xpos <= Xmin) {
	Xpos = Xmin;
	Xvel = -Xvel;
	Zstep = -Zstep;
    }
    Ypos += Yvel;
    Yvel += G;
    if (Ypos < Ymin) {
	Ypos = Ymin;
	if (vel0 == -100.0)
	    vel0 = fabs(Yvel);
	Yvel = vel0;
    }
    
    return;
}


- (void)GLresize:sender
{
    glViewport(0, 0, (GLint)[self bounds].size.width, (GLint)[self bounds].size.height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-6.0, 6.0, -6.0, 6.0, -6.0, 6.0);
    glMatrixMode(GL_MODELVIEW);
    
    return;
}


- (GLuint)makeBall
{
    GLuint list;
    GLfloat a, b;
    GLfloat da = 18.0, db = 18.0;
    GLfloat radius = 1.0;
    GLuint color;
    GLfloat x, y, z;

    list = glGenLists(1);

    glNewList(list, GL_COMPILE);

    color = 0;
    for (a = -90.0; a + da <= 90.0; a += da) {
	
	glBegin(GL_QUAD_STRIP);
	for (b = 0.0; b <= 360.0; b += db) {
	    
	    if (color) {
		glColor3f(1.0, 0.0, 0.0);
	    } else {
		glColor3f(1.0, 1.0, 1.0);
	    }
	    
	    x = COS(b) * COS(a);
	    y = SIN(b) * COS(a);
	    z = SIN(a);
	    glVertex3f(x, y, z);
	    
	    x = radius * COS(b) * COS(a + da);
	    y = radius * SIN(b) * COS(a + da);
	    z = radius * SIN(a + da);
	    glVertex3f(x, y, z);
	    
	    color = 1 - color;
	}
	glEnd();
	
    }
    
    glEndList();
    
    return list;
}



@end


